//===========================================================================
// package
//===========================================================================
package jp.gr.java_conf.bugslife.selections;

//===========================================================================
// import
//===========================================================================
// Java core API
import java.util.*;
import java.text.*;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

// DB API
import jp.gr.java_conf.bugslife.db.*;

// Util API
import jp.gr.java_conf.bugslife.util.*;
//import jp.gr.java_conf.bugslife.system.*;


/**
 *<PRE>
 * 
 * ComponentNameクラス
 * 
 *</PRE>
 * @version	0.0, 2001/09/10
 * @author	鰐川　正寛
 */
//===========================================================================
public class ComponentName implements IUpdatable, ILoadable
{
//===========================================================================
// attributes
//===========================================================================
	/**
	 *	コンポーネントＩＤ
	 */
	private String m_cpid = null;
	/**
	 *	コンポーネント名称
	 */
	private String m_name = null;
	/**
	 *	リソース
	 */
	private String m_resource = null;
	/**
	 *	説明
	 */
	private String m_info = null;
	//add 08.02.11
	/**
	 *	表示フラグ
	 */
	private byte m_dispFlag = 1;
	/**
	 *	更新者
	 */
	private int m_updateUno = 0;
	/**
	 *	更新日時
	 */
	private Date m_updateDate = new Date();
//=====================================
// DB用項目定義
//=====================================
	/**
	 * 排他制御
	 */
	private static final boolean EXCLUSION = true;	//あり
	/**
	 * AutoIncrement
	 */
	private static final boolean ATOINCREMENT = false;	//なし
	/**
	 * PK 
	 */
	private static final String[] PK = {"cpid"};
	/**
	 * 更新項目名
	 */
	private static final String[] DB_ITEMS = {
									"cpid","name","resource",
									"dispFlag",					//08.02.11
									"info","updateUno" };
	/**
	 * Log
	 */
	private Log log = LogFactory.getLog(this.getClass().getName());
//===========================================================================
// methods
//===========================================================================
	/**
	 *	デフォルトコンストラクタ
	 *
	 */
	public ComponentName()
	{
		
	}
	/**
	 *	コンストラクタ(ＩＤ指定）
	 *
	 * @param	 cpid		String型
	 */
	public ComponentName(String cpid)
	{
		setCpid(cpid);
		
		load();
		
	}
//======================================
// db access methods
//======================================
	/**
	 *	insertDB
	 *
	 * @return	処理結果
	 */
	public void insert(int updateUno)
	{
		setUpdateUno(updateUno);
		DAO.insert(this);
		load();		//最終更新日がほしいので再ロード
	}
	/**
	 *	update
	 *
	 * @return	処理結果
	 */
	public void update(int updateUno)
	{
		setUpdateUno(updateUno);
		DAO.update(this);
		load();		//最終更新日がほしいので再ロード
	}
	/**
	 *	delete
	 *
	 * @return	処理結果
	 */
	public void delete(int updateUno)
	{
		setUpdateUno(updateUno);
		DAO.delete(this);
	}
	/**
	 *	load
	 *
	 * @return	処理結果
	 */
	public void load()
	{
		DAO.load(this);
	}
	/**
	 *	findAll
	 *
	 * @return	処理結果
	 */
	public static Collection findAll()
	{
		return DAO.findAll(new ComponentName());
	}
	/**
	 *	ComponentNameの取得（コード指定）
	 *
	 * @return	処理結果
	 */
	public static ComponentName getComponentName(String cpid)
	{
		String sql = "SELECT * FROM ComponentName WHERE cpid = ?";
		ArrayList params = new ArrayList();
		params.add(cpid);
		
		ArrayList list = DAO.find(new ComponentName(), sql, params);
		
		ComponentName ComponentName = null;
		if ((list != null) && (list.size() > 0)) {
			ComponentName = (ComponentName)list.get(0);
		}
		return ComponentName;
	}
	//add  08.02.11
	/**
	 * ラベル表示用コレクション
	 */
	public static Collection getLabelCollection()
	{
		String sql = "SELECT cpid,name FROM ComponentName where dispFlag = 1 ORDER BY cpid";
		ArrayList params = new ArrayList();
		
		ArrayList list = DAO.find(new ComponentName(), sql, params);
		
		return list;
	}
	/**
	 * ラベル表示用コレクション(非表示含む）
	 */
	public static Collection getLabelCollectionForAdmin()
	{
		String sql = "SELECT cpid,name FROM ComponentName ORDER BY cpid";
		ArrayList params = new ArrayList();
		
		ArrayList list = DAO.find(new ComponentName(), sql, params);
		
		return list;
	}

//======================================
// Db Interface
//======================================
	/**
	 * 
	 */
	public String[] getUpdateItemNames() {
		
		return DB_ITEMS;
		
	}
	/**
	 * PK items
	 */
	 public String[] getPKItems() {
		return PK;
	}
	/**
	 * 排他制御ありなし
	 */
	public boolean isExclusion() {
		return EXCLUSION;
	}
	/**
	 * AutoIncrementありなし
	 */
	public boolean isAutoIncrement() {
		return ATOINCREMENT;
	}
//======================================
// request param
//======================================
	/**
	 *	request parametorの生成
	 */
	public Map getMapping() {
		HashMap map = new HashMap();
		map.put("t", "ComponentName");
		map.put("cpid", m_cpid);
		return map;
	}
//======================================
// Property
//======================================
	/**
	 * 画面IDの取得
	 * 
	 * @return 画面ID
	 */
	public String getCpid()
	{
		return m_cpid;
	}
	/**
	 * 画面IDのセット
	 * 
	 * @param cpid 画面ID
	 */
	public void setCpid(String cpid)
	{
		m_cpid = cpid;
	}
	/**
	 * 名前の取得
	 * 
	 * @return 名前
	 */
	public String getName()
	{
		return m_name;
	}
	/**
	 * 名前のセット
	 * 
	 * @param name 名前
	 */
	public void setName(String name)
	{
		m_name = name;
	}
	/**
	 * リソースの取得
	 * 
	 * @return リソース
	 */
	public String getResource()
	{
		return m_resource;
	}
	/**
	 * リソースのセット
	 * 
	 * @param resource リソース
	 */
	public void setResource(String resource)
	{
		m_resource = resource;
	}
	/**
	 * 説明の取得
	 * 
	 * @return 説明
	 */
	public String getInfo()
	{
		return m_info;
	}
	/**
	 * 説明のセット
	 * 
	 * @param info 説明
	 */
	public void setInfo(String info)
	{
		m_info = info;
	}
	/**
	 * 更新者の取得
	 * 
	 * @return 更新者
	 */
	public int getUpdateUno()
	{
		return m_updateUno;
	}
	/**
	 * 更新者のセット
	 * 
	 * @param updateUno 更新者
	 */
	public void setUpdateUno(int updateUno)
	{
		m_updateUno = updateUno;
	}
	/**
	 *	更新日の取得
	 *
	 * @return	update		更新日文字列
	 */
	public Date getUpdateDate()
	{
		return m_updateDate;
	}
	/**
	 *	更新日の取得
	 *
	 * @return	update		更新日文字列
	 */
	public String getUpdateDateString()
	{
		return Converter.getDateString(m_updateDate);
	}
	/**
	 *	更新日のセット
	 *
	 * @return	update		更新日文字列
	 */
	public void setUpdateDate(Date date)
	{
		m_updateDate = date;
	}
    /**
     * @return 表示フラグ を戻します。
     */
    public byte getDispFlag() {
        return m_dispFlag;
    }
    /**
     * @param pFlag 表示フラグ を設定。
     */
    public void setDispFlag(byte pFlag) {
        m_dispFlag = pFlag;
    }
//===========================================================================
// debug methods
//===========================================================================
	/**
	 *	クラス情報
	 */
	public String toString()
	{
		StringBuffer sb = new StringBuffer();
		sb.append("--- [ComponentName] --- \n");
		sb.append("cpid     : " + m_cpid + "\n");
		sb.append("name     : " + m_name + "\n");
		sb.append("resource : " + m_resource + "\n");
		sb.append("info     : " + m_info + "\n");
		//08.02.11
		sb.append("dispflag : " + m_dispFlag + "\n");
		
		sb.append("updateUno: " + m_updateUno + "\n");
		sb.append("updateDat: " + getUpdateDateString() + "\n");
		sb.append("--- [ComponentName] --- \n");
		return sb.toString();
	}
//===========================================================================
// test codes
//===========================================================================
	/**
	 *	テストメイン
	 */
	public static void main(String[] args)
	{
		System.out.println("------- << ComponentName Test Start >> -----------");
		unitTest1();	//新規作成テスト
		unitTest2();	//更新テスト
		unitTest3();	//削除テスト
		unitTest4();	//全件取得テスト
		unitTest5();	//コード指定コンストラクトテスト
		unitTest6();	//ラベル用コレクションテスト
		
		System.out.println("------- << ComponentName Test End >> -----------");
	}
	
	/**
	 *	unitTest1
	 *
	 * 新規作成テスト
	 *
	 */
	public static void unitTest1()
	{
		System.out.println("------- unitTest1 -----------");
		
		//存在チェック
		ComponentName target = ComponentName.getComponentName("ALL");
		if (target != null) {
			//存在していたら削除する
			target.delete(1);
		}
		//値のセット
		ComponentName compo = new ComponentName();
		compo.setCpid("ALL");
		compo.setName("全部");
		compo.setResource("リソース");
		compo.setInfo("説明");
		
		//追加
		compo.insert(0);
		
		System.out.println(compo.toString());
	}
	/**
	 *	unitTest2
	 *
	 * 更新テスト
	 *
	 */
	public static void unitTest2()
	{
		System.out.println("------- unitTest2 -----------");
		
		//存在チェック
		ComponentName compo = ComponentName.getComponentName("ALL");
		if (compo == null) {
			//存在していなかったらテスト中止
			throw new Error("target is nothing");
		}
		
		System.out.println(compo.toString());
		
		compo.setName("全部２");
		compo.setResource("リソース２");
		compo.setInfo("説明２");
		//更新
		compo.update(1);
		
		System.out.println(compo.toString());
	}
	/**
	 *	unitTest3
	 *
	 * 削除テスト
	 *
	 */
	public static void unitTest3()
	{
		System.out.println("------- unitTest3 -----------");
		
		//存在チェック
		ComponentName compo = ComponentName.getComponentName("ALL");
		if (compo == null) {
			//存在していなかったらテスト中止
			throw new Error("target is nothing");
		}
		
		System.out.println(compo.toString());
		
		//削除
		compo.delete(2);
		
		//存在チェック
		compo = ComponentName.getComponentName("ALL");
		if (compo != null) {
			//存在していなかったらテスト中止
			throw new Error("delete failer");
		}
	}
	/**
	 *	unitTest4
	 *
	 * 全件取得テスト
	 *
	 */
	public static void unitTest4()
	{
		System.out.println("------- unitTest4 -----------");
		
		Collection list = ComponentName.findAll();
		display(list);
	}
	/**
	 *	unitTest5
	 *
	 * コードコンストラクトテスト
	 *
	 */
	public static void unitTest5()
	{
		System.out.println("------- unitTest5 -----------");
		
		ComponentName ComponentName = new ComponentName("ASP");
		
		System.out.println(ComponentName.toString());
	}
	/**
	 *	unitTest6
	 *
	 * ラベル用コレクションの取得
	 *
	 */
	public static void unitTest6()
	{
		System.out.println("------- unitTest6 -----------");
		
		display(ComponentName.getLabelCollection());
		
	}
	/**
	 * リストの表示
	 *
	 */
	private static void display(Collection list)
	{
		Iterator ite = list.iterator();
		
		while(ite.hasNext()) {
			ComponentName ComponentName = (ComponentName)ite.next();
			
			System.out.println(ComponentName.getName());
		}
	}
}